/**
 * Licensed Materials - Property of CognosPaul 
 */
define([], function() {
	'use strict';

	var ClipboardEditor = function(){
		
		/**
		 * Called by the AppController whenever this view is created
		 *
		 * @public
		 * @returns {Promise} promise resolved to the root DOM element for this view.
		 */
		this.isVisible = function(context, target) {
			return true;
		},
		
		/**
		 * Called by the AppController whenever this view is destroyed
		 *
		 * @public
		 */
		this.execute = function(context, target) {

    var currFrame = null
        , currFrameID = window.__glassAppController.getCurrentContentView().id;
	
  
    //find the current frame
    for(var i=0;i<window.frames.length;++i){
		
      if(window.frames[i].Application.GlassView && window.frames[i].Application.GlassView.id==currFrameID) {
		  currFrame=window.frames[i];
      break;}
    }
    
    
    
    //Find all obfuscated objects
    var obs = [];

    //the value we're looking for is hidden inside an object starting with an underscore. 
    for(var a in currFrame){
      if(typeof(currFrame[a])=='object'&& a.substr(0,1)=='_') obs.push(a)
    }

    /* now we can start looping through the obfuscated objects looking for 
     * what we want. We'll label it to break out quickly
     */

    obfusearch: 
    for(var i=0;i<obs.length;++i){
      var obj = currFrame[obs[i]];
      
      //identify the object that has the RSClipboard
      for(var a in obj){
        if(typeof(obj[a])=='string' && obj[a].match('RSClipboard')){
        //now this means that obj has the clipboard and b is either the flag or the item that holds it. The item that holds it is either an empty string or has /RSClipboard
          for(var b in obj){
            if(typeof(obj[b])=='string' && (obj[b].match('/RSClipboard')||obj[b]=="")){
              var cb = obj[b];
              break obfusearch;
            }
          }
        }
      }
    }
    
    var 
        innerBox      = document.createElement('div')
      , cancel        = document.createElement('input')
      , finish        = document.createElement('input')
      , overlay       = document.createElement('div')
      , btnBox        = document.createElement('div')
      , memobox       = document.createElement('textarea')
      
     
      , fnCancel      = function(){
        innerBox.parentNode.removeChild(innerBox);
        overlay.parentNode.removeChild(overlay);

      }
      , fnFinish      = function(memobox, cb){
          obj[b]=memobox.value;
          innerBox.parentNode.removeChild(innerBox);
          overlay.parentNode.removeChild(overlay);

        }
      
    ;
   

    memobox.value=cb;
    memobox.style.width='100%';
    memobox.style.height='400px';
    
    innerBox.style.height='500px';
    innerBox.style.width='500px';  
    innerBox.style.marginLeft='auto';
    innerBox.style.marginRight='auto';
    innerBox.style.marginTop='10%';
    innerBox.style.overflow='auto';
    innerBox.style.position='relative';
    innerBox.style.backgroundColor='white';
    innerBox.style.zIndex=2000;
   
    
    innerBox.appendChild(memobox);
   
    cancel.type='button';
    cancel.value = 'Cancel';
    cancel.onclick = function(){fnCancel()};
    btnBox.appendChild(cancel);
    
    finish.value='Finish';
    finish.type='button';
    finish.onclick = function(){fnFinish(memobox, cb)};
    btnBox.appendChild(finish);
    
    innerBox.appendChild(btnBox);
    
    overlay.style.height='100%';
    overlay.style.width='100%';
    overlay.style.backgroundColor='black';
    overlay.style.position='absolute';
    overlay.style.zIndex=1000;
    overlay.style.opacity=0.8;
    
    document.body.appendChild(overlay);
    document.body.appendChild(innerBox);
    
 // }
		}
		
		

	};

	return ClipboardEditor;

});
